# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from kvh_geo_fog_3d_msgs/KvhGeoFog3DOdometerState.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class KvhGeoFog3DOdometerState(genpy.Message):
  _md5sum = "ad1ea6dcb90cd37b148a7adf7f50b0d7"
  _type = "kvh_geo_fog_3d_msgs/KvhGeoFog3DOdometerState"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """####################################
# UTM Position message for KVH GEO FOG 3D UTM position packet
####################################

#
# ROS message header.
# header.stamp specifies the ROS time for this measurement. Satellite
# time is reported as unix_time_s and unix_time_us.
#
Header header

#
# Odometer Pulse Count
# Counts number of ticks recieved from the odometer 
#
int32 odometer_pulse_count

#
# Odometer distance
# Shows distance travelled, which is num_ticks * distance_per_tick
#
float32 odometer_distance_m

#
# Odometer Speed
#
float32 odometer_speed_mps

#
# Odometer Slip
#
float32 odometer_slip_m

#
# Odometer Active
# Documentation unclear, assuming 0 is inactive, and non-zero is active
#
uint8 odometer_active
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id
"""
  __slots__ = ['header','odometer_pulse_count','odometer_distance_m','odometer_speed_mps','odometer_slip_m','odometer_active']
  _slot_types = ['std_msgs/Header','int32','float32','float32','float32','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,odometer_pulse_count,odometer_distance_m,odometer_speed_mps,odometer_slip_m,odometer_active

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(KvhGeoFog3DOdometerState, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.odometer_pulse_count is None:
        self.odometer_pulse_count = 0
      if self.odometer_distance_m is None:
        self.odometer_distance_m = 0.
      if self.odometer_speed_mps is None:
        self.odometer_speed_mps = 0.
      if self.odometer_slip_m is None:
        self.odometer_slip_m = 0.
      if self.odometer_active is None:
        self.odometer_active = 0
    else:
      self.header = std_msgs.msg.Header()
      self.odometer_pulse_count = 0
      self.odometer_distance_m = 0.
      self.odometer_speed_mps = 0.
      self.odometer_slip_m = 0.
      self.odometer_active = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_i3fB().pack(_x.odometer_pulse_count, _x.odometer_distance_m, _x.odometer_speed_mps, _x.odometer_slip_m, _x.odometer_active))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 17
      (_x.odometer_pulse_count, _x.odometer_distance_m, _x.odometer_speed_mps, _x.odometer_slip_m, _x.odometer_active,) = _get_struct_i3fB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_i3fB().pack(_x.odometer_pulse_count, _x.odometer_distance_m, _x.odometer_speed_mps, _x.odometer_slip_m, _x.odometer_active))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 17
      (_x.odometer_pulse_count, _x.odometer_distance_m, _x.odometer_speed_mps, _x.odometer_slip_m, _x.odometer_active,) = _get_struct_i3fB().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_i3fB = None
def _get_struct_i3fB():
    global _struct_i3fB
    if _struct_i3fB is None:
        _struct_i3fB = struct.Struct("<i3fB")
    return _struct_i3fB
