# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from kvh_geo_fog_3d_msgs/KvhGeoFog3DRawGNSS.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class KvhGeoFog3DRawGNSS(genpy.Message):
  _md5sum = "e25b527e0761cbfb2a1bbd054b402e24"
  _type = "kvh_geo_fog_3d_msgs/KvhGeoFog3DRawGNSS"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """###############################################
# Raw GNSS message for the KVH GEO FOG 3D raw GNSS packet
###############################################

#
# This message contains completely raw data. This is,
# it has not been passed through the KVH kalman filters
#

#
# ROS message header.
# header.stamp specifies the ROS time for this measurement. Satellite
# time is reported as unix_time_s and unix_time_us.
#
Header header

#
# Unix time stamp seconds and microseconds
# To get full time add them together
#
uint32 unix_time_s
uint32 unix_time_us

#
# Longitude and Latitude in radians
#
float64 latitude_rad
float64 longitude_rad

#
# Height in meters
#
float64 height_m

#
# Velocity North, East, and Down in meters
#
float32 vel_north_m
float32 vel_east_m
float32 vel_down_m

#
# Standard deviation lat, long, and height in m
#
float32 latitude_stddev_m
float32 longitude_stddev_m
float32 height_stddev_m

#
# Tilt and Heading in radians
#
float32 tilt_rad
float32 heading_rad

#
# Tilt and Heading std deviation in radians
#
float32 tilt_stddev_rad
float32 heading_stddev_rad

#
# Raw GNSS Status
# Bits 0,1,2 value in binary
# 0 - No GNSS Fix
# 1 - 2D GNSS Fix 
# 2 - 3D GNSS Fix
# 3 - SBAS GNSS Fix
# 4 - Differential GNSS Fix
# 5 - Omnistar/Starfire GNSS Fix
# 6 - RTK Float GNSS Fix
# 7 - RTF Fixed GNSS Fix 
#
# 3 - Doppler velocity valid
# 4 - Time valid
# 5 - External GNSS valid
# 6 - Tilt valid
# 7 - Heading valid
# 8 - Floating ambiguity heading
# 9-16 - reserved (set to zero)
# 
# We seperate these to different variables for ease
#
uint8 gnss_fix
uint8 doppler_velocity_valid
uint8 time_valid
uint8 external_gnss
uint8 tilt_valid
uint8 heading_valid
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id
"""
  __slots__ = ['header','unix_time_s','unix_time_us','latitude_rad','longitude_rad','height_m','vel_north_m','vel_east_m','vel_down_m','latitude_stddev_m','longitude_stddev_m','height_stddev_m','tilt_rad','heading_rad','tilt_stddev_rad','heading_stddev_rad','gnss_fix','doppler_velocity_valid','time_valid','external_gnss','tilt_valid','heading_valid']
  _slot_types = ['std_msgs/Header','uint32','uint32','float64','float64','float64','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','uint8','uint8','uint8','uint8','uint8','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,unix_time_s,unix_time_us,latitude_rad,longitude_rad,height_m,vel_north_m,vel_east_m,vel_down_m,latitude_stddev_m,longitude_stddev_m,height_stddev_m,tilt_rad,heading_rad,tilt_stddev_rad,heading_stddev_rad,gnss_fix,doppler_velocity_valid,time_valid,external_gnss,tilt_valid,heading_valid

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(KvhGeoFog3DRawGNSS, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.unix_time_s is None:
        self.unix_time_s = 0
      if self.unix_time_us is None:
        self.unix_time_us = 0
      if self.latitude_rad is None:
        self.latitude_rad = 0.
      if self.longitude_rad is None:
        self.longitude_rad = 0.
      if self.height_m is None:
        self.height_m = 0.
      if self.vel_north_m is None:
        self.vel_north_m = 0.
      if self.vel_east_m is None:
        self.vel_east_m = 0.
      if self.vel_down_m is None:
        self.vel_down_m = 0.
      if self.latitude_stddev_m is None:
        self.latitude_stddev_m = 0.
      if self.longitude_stddev_m is None:
        self.longitude_stddev_m = 0.
      if self.height_stddev_m is None:
        self.height_stddev_m = 0.
      if self.tilt_rad is None:
        self.tilt_rad = 0.
      if self.heading_rad is None:
        self.heading_rad = 0.
      if self.tilt_stddev_rad is None:
        self.tilt_stddev_rad = 0.
      if self.heading_stddev_rad is None:
        self.heading_stddev_rad = 0.
      if self.gnss_fix is None:
        self.gnss_fix = 0
      if self.doppler_velocity_valid is None:
        self.doppler_velocity_valid = 0
      if self.time_valid is None:
        self.time_valid = 0
      if self.external_gnss is None:
        self.external_gnss = 0
      if self.tilt_valid is None:
        self.tilt_valid = 0
      if self.heading_valid is None:
        self.heading_valid = 0
    else:
      self.header = std_msgs.msg.Header()
      self.unix_time_s = 0
      self.unix_time_us = 0
      self.latitude_rad = 0.
      self.longitude_rad = 0.
      self.height_m = 0.
      self.vel_north_m = 0.
      self.vel_east_m = 0.
      self.vel_down_m = 0.
      self.latitude_stddev_m = 0.
      self.longitude_stddev_m = 0.
      self.height_stddev_m = 0.
      self.tilt_rad = 0.
      self.heading_rad = 0.
      self.tilt_stddev_rad = 0.
      self.heading_stddev_rad = 0.
      self.gnss_fix = 0
      self.doppler_velocity_valid = 0
      self.time_valid = 0
      self.external_gnss = 0
      self.tilt_valid = 0
      self.heading_valid = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I3d10f6B().pack(_x.unix_time_s, _x.unix_time_us, _x.latitude_rad, _x.longitude_rad, _x.height_m, _x.vel_north_m, _x.vel_east_m, _x.vel_down_m, _x.latitude_stddev_m, _x.longitude_stddev_m, _x.height_stddev_m, _x.tilt_rad, _x.heading_rad, _x.tilt_stddev_rad, _x.heading_stddev_rad, _x.gnss_fix, _x.doppler_velocity_valid, _x.time_valid, _x.external_gnss, _x.tilt_valid, _x.heading_valid))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 78
      (_x.unix_time_s, _x.unix_time_us, _x.latitude_rad, _x.longitude_rad, _x.height_m, _x.vel_north_m, _x.vel_east_m, _x.vel_down_m, _x.latitude_stddev_m, _x.longitude_stddev_m, _x.height_stddev_m, _x.tilt_rad, _x.heading_rad, _x.tilt_stddev_rad, _x.heading_stddev_rad, _x.gnss_fix, _x.doppler_velocity_valid, _x.time_valid, _x.external_gnss, _x.tilt_valid, _x.heading_valid,) = _get_struct_2I3d10f6B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2I3d10f6B().pack(_x.unix_time_s, _x.unix_time_us, _x.latitude_rad, _x.longitude_rad, _x.height_m, _x.vel_north_m, _x.vel_east_m, _x.vel_down_m, _x.latitude_stddev_m, _x.longitude_stddev_m, _x.height_stddev_m, _x.tilt_rad, _x.heading_rad, _x.tilt_stddev_rad, _x.heading_stddev_rad, _x.gnss_fix, _x.doppler_velocity_valid, _x.time_valid, _x.external_gnss, _x.tilt_valid, _x.heading_valid))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 78
      (_x.unix_time_s, _x.unix_time_us, _x.latitude_rad, _x.longitude_rad, _x.height_m, _x.vel_north_m, _x.vel_east_m, _x.vel_down_m, _x.latitude_stddev_m, _x.longitude_stddev_m, _x.height_stddev_m, _x.tilt_rad, _x.heading_rad, _x.tilt_stddev_rad, _x.heading_stddev_rad, _x.gnss_fix, _x.doppler_velocity_valid, _x.time_valid, _x.external_gnss, _x.tilt_valid, _x.heading_valid,) = _get_struct_2I3d10f6B().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2I3d10f6B = None
def _get_struct_2I3d10f6B():
    global _struct_2I3d10f6B
    if _struct_2I3d10f6B is None:
        _struct_2I3d10f6B = struct.Struct("<2I3d10f6B")
    return _struct_2I3d10f6B
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
