# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from kvh_geo_fog_3d_msgs/KvhGeoFog3DRawSensors.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class KvhGeoFog3DRawSensors(genpy.Message):
  _md5sum = "0fa2feeb688ce558f0c15ac343f26e6a"
  _type = "kvh_geo_fog_3d_msgs/KvhGeoFog3DRawSensors"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """###############################################
# Raw Sensors message for the KVH GEO FOG 3D raw sensors packet
###############################################

#
# This message contains completely raw data. This is,
# it has not been passed through the KVH kalman filters
#

#
# ROS message header.
# header.stamp specifies the ROS time for this measurement. Satellite
# time is reported as unix_time_s and unix_time_us.
#
Header header

#
# Accelerometer X,Y,Z in m/s^2
#
float32 accelerometer_x_mpss
float32 accelerometer_y_mpss
float32 accelerometer_z_mpss

#
# Gyroscope X,Y,Z rad/s
#
float32 gyro_x_rps
float32 gyro_y_rps
float32 gyro_z_rps

#
# Mangetometer in mG
#
float32 magnetometer_x_mG
float32 magnetometer_y_mG
float32 magnetometer_z_mG

#
# IMU Temperature deg C
#
float32 imu_temp_c

#
# Pressure in pascals
#
float32 pressure_pa

#
# Pressure Temperature deg C
#
float32 pressure_temp_c

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id
"""
  __slots__ = ['header','accelerometer_x_mpss','accelerometer_y_mpss','accelerometer_z_mpss','gyro_x_rps','gyro_y_rps','gyro_z_rps','magnetometer_x_mG','magnetometer_y_mG','magnetometer_z_mG','imu_temp_c','pressure_pa','pressure_temp_c']
  _slot_types = ['std_msgs/Header','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,accelerometer_x_mpss,accelerometer_y_mpss,accelerometer_z_mpss,gyro_x_rps,gyro_y_rps,gyro_z_rps,magnetometer_x_mG,magnetometer_y_mG,magnetometer_z_mG,imu_temp_c,pressure_pa,pressure_temp_c

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(KvhGeoFog3DRawSensors, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.accelerometer_x_mpss is None:
        self.accelerometer_x_mpss = 0.
      if self.accelerometer_y_mpss is None:
        self.accelerometer_y_mpss = 0.
      if self.accelerometer_z_mpss is None:
        self.accelerometer_z_mpss = 0.
      if self.gyro_x_rps is None:
        self.gyro_x_rps = 0.
      if self.gyro_y_rps is None:
        self.gyro_y_rps = 0.
      if self.gyro_z_rps is None:
        self.gyro_z_rps = 0.
      if self.magnetometer_x_mG is None:
        self.magnetometer_x_mG = 0.
      if self.magnetometer_y_mG is None:
        self.magnetometer_y_mG = 0.
      if self.magnetometer_z_mG is None:
        self.magnetometer_z_mG = 0.
      if self.imu_temp_c is None:
        self.imu_temp_c = 0.
      if self.pressure_pa is None:
        self.pressure_pa = 0.
      if self.pressure_temp_c is None:
        self.pressure_temp_c = 0.
    else:
      self.header = std_msgs.msg.Header()
      self.accelerometer_x_mpss = 0.
      self.accelerometer_y_mpss = 0.
      self.accelerometer_z_mpss = 0.
      self.gyro_x_rps = 0.
      self.gyro_y_rps = 0.
      self.gyro_z_rps = 0.
      self.magnetometer_x_mG = 0.
      self.magnetometer_y_mG = 0.
      self.magnetometer_z_mG = 0.
      self.imu_temp_c = 0.
      self.pressure_pa = 0.
      self.pressure_temp_c = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_12f().pack(_x.accelerometer_x_mpss, _x.accelerometer_y_mpss, _x.accelerometer_z_mpss, _x.gyro_x_rps, _x.gyro_y_rps, _x.gyro_z_rps, _x.magnetometer_x_mG, _x.magnetometer_y_mG, _x.magnetometer_z_mG, _x.imu_temp_c, _x.pressure_pa, _x.pressure_temp_c))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 48
      (_x.accelerometer_x_mpss, _x.accelerometer_y_mpss, _x.accelerometer_z_mpss, _x.gyro_x_rps, _x.gyro_y_rps, _x.gyro_z_rps, _x.magnetometer_x_mG, _x.magnetometer_y_mG, _x.magnetometer_z_mG, _x.imu_temp_c, _x.pressure_pa, _x.pressure_temp_c,) = _get_struct_12f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_12f().pack(_x.accelerometer_x_mpss, _x.accelerometer_y_mpss, _x.accelerometer_z_mpss, _x.gyro_x_rps, _x.gyro_y_rps, _x.gyro_z_rps, _x.magnetometer_x_mG, _x.magnetometer_y_mG, _x.magnetometer_z_mG, _x.imu_temp_c, _x.pressure_pa, _x.pressure_temp_c))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 48
      (_x.accelerometer_x_mpss, _x.accelerometer_y_mpss, _x.accelerometer_z_mpss, _x.gyro_x_rps, _x.gyro_y_rps, _x.gyro_z_rps, _x.magnetometer_x_mG, _x.magnetometer_y_mG, _x.magnetometer_z_mG, _x.imu_temp_c, _x.pressure_pa, _x.pressure_temp_c,) = _get_struct_12f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_12f = None
def _get_struct_12f():
    global _struct_12f
    if _struct_12f is None:
        _struct_12f = struct.Struct("<12f")
    return _struct_12f
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
