# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from kvh_geo_fog_3d_msgs/KvhGeoFog3DSystemState.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class KvhGeoFog3DSystemState(genpy.Message):
  _md5sum = "7709efc2bde794dac89052cbc8853682"
  _type = "kvh_geo_fog_3d_msgs/KvhGeoFog3DSystemState"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """############################################################################
# System Status message for the KVH GEO FOG 3D
#
# All fields with units of measure are accompanied by suffixes listed here.
# These fields mirror exactly what comes out of the KVH INS, and thus
# may or may not conform to ROS REP 103.
#
# Suffixes used in this file:
#  s         - seconds
#  us        - microseconds
#  rad       - radians
#  m         - meters
#  mps       - meters per second
#  g         - g-force
#  rad_per_s - radians per second
#
# The coordinate frame in header.frame_id is centered at the center base of
# the sensor, with X pointing forward, Y pointing right, and Z pointing
# downward. All values are with respect to this coordinate frame.
# Notably, this does not comply with ROS REP 105, but is standard practice
# amongs localization system providers.
############################################################################

#
# ROS message header.
# header.stamp specifies the ROS time for this measurement. Satellite
# time is reported as unix_time_s and unix_time_us.
#
Header header

#
# System status bitmask, as reported by the KVH GEO FOG 3D.
# Each bit is a boolean representing a specific subsystem.
# Bits:
#  0  - System Failure
#  1  - Accelerometer sensor failure
#  2  - Gyroscope sensor failure
#  3  - Magnetometer sensor failure
#  4  - Pressure sensor failure
#  5  - GNSS failure
#  6  - Accelerometer over range
#  7  - Gyroscope over range
#  8  - Magnetometer over range
#  9  - Pressure over range
#  10 - Minimum temperature alarm
#  11 - Maximum temperature alarm
#  12 - Low voltage alarm
#  13 - High voltage alarm
#  14 - GNSS antenna disconnected
#  15 - Data output overflow alarm
#
uint16 system_status

#
# Filter status bitmask, as reported by the KVH GEO FOG 3D.
# Each bit is a boolean representing a specific subsystem.
# Bits:
#  0    - Orientation filter initialized
#  1    - Navigation filter initialized
#  2    - Heading initialized
#  3    - UTC Time initialized
#  4-6  - GNSS fix status (see below)
#  7    - Event 1 occurred
#  8    - Event 2 occurred
#  9    - Internal GNSS enabled
#  10   - Dual antenna heading active
#  11   - Velocity heading enabled
#  12   - Atmospheric altitude enabled
#  13   - External position active
#  14   - External velocity active
#  15   - External heading active
#
# GNSS fix status values (3 bits represented as unsigned integer):
#  0 - No GNSS fix
#  1 - 2D GNSS fix
#  2 - 3D NGSS fix
#  3 - SBAS GNSS fix
#  4 - Differential GNSS fix
#  5 - Omnistar/Starfire GNSS fix
#  6 - RTK Float GNSS fix
#  7 - RTK Fixed GNSS fix
#
uint16 filter_status

#
# UTC time in seconds since January 1st, 1970, including leap seconds
#
uint32 unix_time_s

#
# Sub-second component of time, represented as microseconds since the last
# second. [0,999999]
#
uint32 unix_time_us

#
# Latitude, in radians
#
float64 latitude_rad

#
# Longitude, in radians
#
float64 longitude_rad

#
# Height above WGS84 ellipsoid, in meters.
#
float64 height_m

#
# Velocity with respect to true north, in meters per second
#
float32 absolute_velocity_north_mps

#
# Eastward velocity in the right-handed coordinate frame northward pointing towards
# true north, in meters per second
#
float32 absolute_velocity_east_mps

#
# Downward velocity in the right-handed coordinate frame northward pointing towards
# true north, in meters per second
#
float32 absolute_velocity_down_mps

#
# If mounted to the vehicle rigidly with the suggested orientation from KVH
# (X points forward, Y points right, Z points down), then body_acceleration_x
# is the acceleration front to back, with positive (+) values meaning vehicle
# acceleration forward.
#
float32 body_acceleration_x_mps

#
# If mounted to the vehicle rigidly with the suggested orientation from KVH
# (X points forward, Y points right, Z points down), then body_acceleration_y
# is the acceleration sideways, with positive (+) values meaning vehicle
# accelerating to the right.
#
float32 body_acceleration_y_mps

#
# If mounted to the vehicle rigidly with the suggested orientation from KVH
# (X points forward, Y points right, Z points down), then body_acceleration_z
# is the acceleration up and down, with positive (+) values meaning vehicle
# acceleration downward.
#
float32 body_acceleration_z_mps

#
# Acceleration on the system, represented as g-force.
#
float32 g_force_g

#
# Roll of the system off of gravitational level, in radians
# [-pi,pi)
#
float32 roll_rad

#
# Pitch of the system off of gravitational level, in radians
# [-pi,pi)
#
float32 pitch_rad

#
# Heading angle of the system with respect to true north, in radians
# [0,2*pi)
#
float32 heading_rad

#
# Angular velocity of the system about the X axis, in radians per second.
#
float32 angular_velocity_x_rad_per_s

#
# Angular velocity of the system about the Y axis, in radians per second.
#
float32 angular_velocity_y_rad_per_s

#
# Angular velocity of the system about the Z axis, in radians per second.
#
float32 angular_velocity_z_rad_per_s

#
# Standard deviation of latitude, in meters
#
float32 latitude_stddev_m

#
# Standard deviation of longitude, in meters
#
float32 longitude_stddev_m

#
# Standard deviation of height, in meters
#
float32 height_stddev_m

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id
"""
  __slots__ = ['header','system_status','filter_status','unix_time_s','unix_time_us','latitude_rad','longitude_rad','height_m','absolute_velocity_north_mps','absolute_velocity_east_mps','absolute_velocity_down_mps','body_acceleration_x_mps','body_acceleration_y_mps','body_acceleration_z_mps','g_force_g','roll_rad','pitch_rad','heading_rad','angular_velocity_x_rad_per_s','angular_velocity_y_rad_per_s','angular_velocity_z_rad_per_s','latitude_stddev_m','longitude_stddev_m','height_stddev_m']
  _slot_types = ['std_msgs/Header','uint16','uint16','uint32','uint32','float64','float64','float64','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32','float32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,system_status,filter_status,unix_time_s,unix_time_us,latitude_rad,longitude_rad,height_m,absolute_velocity_north_mps,absolute_velocity_east_mps,absolute_velocity_down_mps,body_acceleration_x_mps,body_acceleration_y_mps,body_acceleration_z_mps,g_force_g,roll_rad,pitch_rad,heading_rad,angular_velocity_x_rad_per_s,angular_velocity_y_rad_per_s,angular_velocity_z_rad_per_s,latitude_stddev_m,longitude_stddev_m,height_stddev_m

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(KvhGeoFog3DSystemState, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.system_status is None:
        self.system_status = 0
      if self.filter_status is None:
        self.filter_status = 0
      if self.unix_time_s is None:
        self.unix_time_s = 0
      if self.unix_time_us is None:
        self.unix_time_us = 0
      if self.latitude_rad is None:
        self.latitude_rad = 0.
      if self.longitude_rad is None:
        self.longitude_rad = 0.
      if self.height_m is None:
        self.height_m = 0.
      if self.absolute_velocity_north_mps is None:
        self.absolute_velocity_north_mps = 0.
      if self.absolute_velocity_east_mps is None:
        self.absolute_velocity_east_mps = 0.
      if self.absolute_velocity_down_mps is None:
        self.absolute_velocity_down_mps = 0.
      if self.body_acceleration_x_mps is None:
        self.body_acceleration_x_mps = 0.
      if self.body_acceleration_y_mps is None:
        self.body_acceleration_y_mps = 0.
      if self.body_acceleration_z_mps is None:
        self.body_acceleration_z_mps = 0.
      if self.g_force_g is None:
        self.g_force_g = 0.
      if self.roll_rad is None:
        self.roll_rad = 0.
      if self.pitch_rad is None:
        self.pitch_rad = 0.
      if self.heading_rad is None:
        self.heading_rad = 0.
      if self.angular_velocity_x_rad_per_s is None:
        self.angular_velocity_x_rad_per_s = 0.
      if self.angular_velocity_y_rad_per_s is None:
        self.angular_velocity_y_rad_per_s = 0.
      if self.angular_velocity_z_rad_per_s is None:
        self.angular_velocity_z_rad_per_s = 0.
      if self.latitude_stddev_m is None:
        self.latitude_stddev_m = 0.
      if self.longitude_stddev_m is None:
        self.longitude_stddev_m = 0.
      if self.height_stddev_m is None:
        self.height_stddev_m = 0.
    else:
      self.header = std_msgs.msg.Header()
      self.system_status = 0
      self.filter_status = 0
      self.unix_time_s = 0
      self.unix_time_us = 0
      self.latitude_rad = 0.
      self.longitude_rad = 0.
      self.height_m = 0.
      self.absolute_velocity_north_mps = 0.
      self.absolute_velocity_east_mps = 0.
      self.absolute_velocity_down_mps = 0.
      self.body_acceleration_x_mps = 0.
      self.body_acceleration_y_mps = 0.
      self.body_acceleration_z_mps = 0.
      self.g_force_g = 0.
      self.roll_rad = 0.
      self.pitch_rad = 0.
      self.heading_rad = 0.
      self.angular_velocity_x_rad_per_s = 0.
      self.angular_velocity_y_rad_per_s = 0.
      self.angular_velocity_z_rad_per_s = 0.
      self.latitude_stddev_m = 0.
      self.longitude_stddev_m = 0.
      self.height_stddev_m = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2H2I3d16f().pack(_x.system_status, _x.filter_status, _x.unix_time_s, _x.unix_time_us, _x.latitude_rad, _x.longitude_rad, _x.height_m, _x.absolute_velocity_north_mps, _x.absolute_velocity_east_mps, _x.absolute_velocity_down_mps, _x.body_acceleration_x_mps, _x.body_acceleration_y_mps, _x.body_acceleration_z_mps, _x.g_force_g, _x.roll_rad, _x.pitch_rad, _x.heading_rad, _x.angular_velocity_x_rad_per_s, _x.angular_velocity_y_rad_per_s, _x.angular_velocity_z_rad_per_s, _x.latitude_stddev_m, _x.longitude_stddev_m, _x.height_stddev_m))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 100
      (_x.system_status, _x.filter_status, _x.unix_time_s, _x.unix_time_us, _x.latitude_rad, _x.longitude_rad, _x.height_m, _x.absolute_velocity_north_mps, _x.absolute_velocity_east_mps, _x.absolute_velocity_down_mps, _x.body_acceleration_x_mps, _x.body_acceleration_y_mps, _x.body_acceleration_z_mps, _x.g_force_g, _x.roll_rad, _x.pitch_rad, _x.heading_rad, _x.angular_velocity_x_rad_per_s, _x.angular_velocity_y_rad_per_s, _x.angular_velocity_z_rad_per_s, _x.latitude_stddev_m, _x.longitude_stddev_m, _x.height_stddev_m,) = _get_struct_2H2I3d16f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2H2I3d16f().pack(_x.system_status, _x.filter_status, _x.unix_time_s, _x.unix_time_us, _x.latitude_rad, _x.longitude_rad, _x.height_m, _x.absolute_velocity_north_mps, _x.absolute_velocity_east_mps, _x.absolute_velocity_down_mps, _x.body_acceleration_x_mps, _x.body_acceleration_y_mps, _x.body_acceleration_z_mps, _x.g_force_g, _x.roll_rad, _x.pitch_rad, _x.heading_rad, _x.angular_velocity_x_rad_per_s, _x.angular_velocity_y_rad_per_s, _x.angular_velocity_z_rad_per_s, _x.latitude_stddev_m, _x.longitude_stddev_m, _x.height_stddev_m))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 100
      (_x.system_status, _x.filter_status, _x.unix_time_s, _x.unix_time_us, _x.latitude_rad, _x.longitude_rad, _x.height_m, _x.absolute_velocity_north_mps, _x.absolute_velocity_east_mps, _x.absolute_velocity_down_mps, _x.body_acceleration_x_mps, _x.body_acceleration_y_mps, _x.body_acceleration_z_mps, _x.g_force_g, _x.roll_rad, _x.pitch_rad, _x.heading_rad, _x.angular_velocity_x_rad_per_s, _x.angular_velocity_y_rad_per_s, _x.angular_velocity_z_rad_per_s, _x.latitude_stddev_m, _x.longitude_stddev_m, _x.height_stddev_m,) = _get_struct_2H2I3d16f().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2H2I3d16f = None
def _get_struct_2H2I3d16f():
    global _struct_2H2I3d16f
    if _struct_2H2I3d16f is None:
        _struct_2H2I3d16f = struct.Struct("<2H2I3d16f")
    return _struct_2H2I3d16f
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
