// Auto-generated. Do not edit!

// (in-package kvh_geo_fog_3d_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class KvhGeoFog3DDetailSatellites {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.satellite_system = null;
      this.satellite_number = null;
      this.satellite_frequencies = null;
      this.elevation_deg = null;
      this.azimuth_deg = null;
      this.snr_decibal = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('satellite_system')) {
        this.satellite_system = initObj.satellite_system
      }
      else {
        this.satellite_system = [];
      }
      if (initObj.hasOwnProperty('satellite_number')) {
        this.satellite_number = initObj.satellite_number
      }
      else {
        this.satellite_number = [];
      }
      if (initObj.hasOwnProperty('satellite_frequencies')) {
        this.satellite_frequencies = initObj.satellite_frequencies
      }
      else {
        this.satellite_frequencies = [];
      }
      if (initObj.hasOwnProperty('elevation_deg')) {
        this.elevation_deg = initObj.elevation_deg
      }
      else {
        this.elevation_deg = [];
      }
      if (initObj.hasOwnProperty('azimuth_deg')) {
        this.azimuth_deg = initObj.azimuth_deg
      }
      else {
        this.azimuth_deg = [];
      }
      if (initObj.hasOwnProperty('snr_decibal')) {
        this.snr_decibal = initObj.snr_decibal
      }
      else {
        this.snr_decibal = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type KvhGeoFog3DDetailSatellites
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [satellite_system]
    bufferOffset = _arraySerializer.uint8(obj.satellite_system, buffer, bufferOffset, null);
    // Serialize message field [satellite_number]
    bufferOffset = _arraySerializer.uint8(obj.satellite_number, buffer, bufferOffset, null);
    // Serialize message field [satellite_frequencies]
    bufferOffset = _arraySerializer.int8(obj.satellite_frequencies, buffer, bufferOffset, null);
    // Serialize message field [elevation_deg]
    bufferOffset = _arraySerializer.uint8(obj.elevation_deg, buffer, bufferOffset, null);
    // Serialize message field [azimuth_deg]
    bufferOffset = _arraySerializer.uint16(obj.azimuth_deg, buffer, bufferOffset, null);
    // Serialize message field [snr_decibal]
    bufferOffset = _arraySerializer.uint8(obj.snr_decibal, buffer, bufferOffset, null);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type KvhGeoFog3DDetailSatellites
    let len;
    let data = new KvhGeoFog3DDetailSatellites(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [satellite_system]
    data.satellite_system = _arrayDeserializer.uint8(buffer, bufferOffset, null)
    // Deserialize message field [satellite_number]
    data.satellite_number = _arrayDeserializer.uint8(buffer, bufferOffset, null)
    // Deserialize message field [satellite_frequencies]
    data.satellite_frequencies = _arrayDeserializer.int8(buffer, bufferOffset, null)
    // Deserialize message field [elevation_deg]
    data.elevation_deg = _arrayDeserializer.uint8(buffer, bufferOffset, null)
    // Deserialize message field [azimuth_deg]
    data.azimuth_deg = _arrayDeserializer.uint16(buffer, bufferOffset, null)
    // Deserialize message field [snr_decibal]
    data.snr_decibal = _arrayDeserializer.uint8(buffer, bufferOffset, null)
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    length += object.satellite_system.length;
    length += object.satellite_number.length;
    length += object.satellite_frequencies.length;
    length += object.elevation_deg.length;
    length += 2 * object.azimuth_deg.length;
    length += object.snr_decibal.length;
    return length + 24;
  }

  static datatype() {
    // Returns string type for a message object
    return 'kvh_geo_fog_3d_msgs/KvhGeoFog3DDetailSatellites';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '62d7332284f15e8afeb0222732662384';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    ##############################
    # Detailed satellites message for KVG GEO FOG 3D detailed satellites packet
    ##############################
    
    #
    # ROS message header.
    # header.stamp specifies the ROS time for this measurement. Satellite
    # time is reported as unix_time_s and unix_time_us.
    #
    Header header 
    
    #
    # Integer enumeration of values
    # Values:
    #   0 - Unknown
    #   1 - GPS
    #   2 - GLONASS
    #   3 - BeiDou
    #   4 - GALILEO
    #   5 - SBAS
    #   6 - QZSS
    #   7 - Starfire
    #   8 - Omnistar 
    #
    uint8[] satellite_system
    
    #
    # Not fully familiar, but seems to be an editable id of 
    # the satellite
    #
    uint8[] satellite_number
    
    #
    # Each bit represents a different satellite frequency
    # Bits:
    #   0 - L1 C/A
    #   1 - L1 C
    #   2 - L1 P
    #   3 - L1 M 
    #   4 - L2 C 
    #   5 - L2 P 
    #   6 - L2 M 
    #   7 - L5
    #
    int8[] satellite_frequencies
    
    #
    # Measurement of the eleveation angle in degrees.
    # Elevation angle is the degree between the horizontal
    # plane and the line of sight in the vertical plane.
    #
    uint8[] elevation_deg
    
    #
    # Measurement of azimuth in degrees.
    # The azimuth is the angle between a body and North. 
    #
    uint16[] azimuth_deg
    
    #
    # Signal to noise ratio in decibels
    #
    uint8[] snr_decibal
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new KvhGeoFog3DDetailSatellites(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.satellite_system !== undefined) {
      resolved.satellite_system = msg.satellite_system;
    }
    else {
      resolved.satellite_system = []
    }

    if (msg.satellite_number !== undefined) {
      resolved.satellite_number = msg.satellite_number;
    }
    else {
      resolved.satellite_number = []
    }

    if (msg.satellite_frequencies !== undefined) {
      resolved.satellite_frequencies = msg.satellite_frequencies;
    }
    else {
      resolved.satellite_frequencies = []
    }

    if (msg.elevation_deg !== undefined) {
      resolved.elevation_deg = msg.elevation_deg;
    }
    else {
      resolved.elevation_deg = []
    }

    if (msg.azimuth_deg !== undefined) {
      resolved.azimuth_deg = msg.azimuth_deg;
    }
    else {
      resolved.azimuth_deg = []
    }

    if (msg.snr_decibal !== undefined) {
      resolved.snr_decibal = msg.snr_decibal;
    }
    else {
      resolved.snr_decibal = []
    }

    return resolved;
    }
};

module.exports = KvhGeoFog3DDetailSatellites;
