// Auto-generated. Do not edit!

// (in-package kvh_geo_fog_3d_msgs.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class KvhGeoFog3DOdometerState {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.header = null;
      this.odometer_pulse_count = null;
      this.odometer_distance_m = null;
      this.odometer_speed_mps = null;
      this.odometer_slip_m = null;
      this.odometer_active = null;
    }
    else {
      if (initObj.hasOwnProperty('header')) {
        this.header = initObj.header
      }
      else {
        this.header = new std_msgs.msg.Header();
      }
      if (initObj.hasOwnProperty('odometer_pulse_count')) {
        this.odometer_pulse_count = initObj.odometer_pulse_count
      }
      else {
        this.odometer_pulse_count = 0;
      }
      if (initObj.hasOwnProperty('odometer_distance_m')) {
        this.odometer_distance_m = initObj.odometer_distance_m
      }
      else {
        this.odometer_distance_m = 0.0;
      }
      if (initObj.hasOwnProperty('odometer_speed_mps')) {
        this.odometer_speed_mps = initObj.odometer_speed_mps
      }
      else {
        this.odometer_speed_mps = 0.0;
      }
      if (initObj.hasOwnProperty('odometer_slip_m')) {
        this.odometer_slip_m = initObj.odometer_slip_m
      }
      else {
        this.odometer_slip_m = 0.0;
      }
      if (initObj.hasOwnProperty('odometer_active')) {
        this.odometer_active = initObj.odometer_active
      }
      else {
        this.odometer_active = 0;
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type KvhGeoFog3DOdometerState
    // Serialize message field [header]
    bufferOffset = std_msgs.msg.Header.serialize(obj.header, buffer, bufferOffset);
    // Serialize message field [odometer_pulse_count]
    bufferOffset = _serializer.int32(obj.odometer_pulse_count, buffer, bufferOffset);
    // Serialize message field [odometer_distance_m]
    bufferOffset = _serializer.float32(obj.odometer_distance_m, buffer, bufferOffset);
    // Serialize message field [odometer_speed_mps]
    bufferOffset = _serializer.float32(obj.odometer_speed_mps, buffer, bufferOffset);
    // Serialize message field [odometer_slip_m]
    bufferOffset = _serializer.float32(obj.odometer_slip_m, buffer, bufferOffset);
    // Serialize message field [odometer_active]
    bufferOffset = _serializer.uint8(obj.odometer_active, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type KvhGeoFog3DOdometerState
    let len;
    let data = new KvhGeoFog3DOdometerState(null);
    // Deserialize message field [header]
    data.header = std_msgs.msg.Header.deserialize(buffer, bufferOffset);
    // Deserialize message field [odometer_pulse_count]
    data.odometer_pulse_count = _deserializer.int32(buffer, bufferOffset);
    // Deserialize message field [odometer_distance_m]
    data.odometer_distance_m = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [odometer_speed_mps]
    data.odometer_speed_mps = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [odometer_slip_m]
    data.odometer_slip_m = _deserializer.float32(buffer, bufferOffset);
    // Deserialize message field [odometer_active]
    data.odometer_active = _deserializer.uint8(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += std_msgs.msg.Header.getMessageSize(object.header);
    return length + 17;
  }

  static datatype() {
    // Returns string type for a message object
    return 'kvh_geo_fog_3d_msgs/KvhGeoFog3DOdometerState';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'ad1ea6dcb90cd37b148a7adf7f50b0d7';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    ####################################
    # UTM Position message for KVH GEO FOG 3D UTM position packet
    ####################################
    
    #
    # ROS message header.
    # header.stamp specifies the ROS time for this measurement. Satellite
    # time is reported as unix_time_s and unix_time_us.
    #
    Header header
    
    #
    # Odometer Pulse Count
    # Counts number of ticks recieved from the odometer 
    #
    int32 odometer_pulse_count
    
    #
    # Odometer distance
    # Shows distance travelled, which is num_ticks * distance_per_tick
    #
    float32 odometer_distance_m
    
    #
    # Odometer Speed
    #
    float32 odometer_speed_mps
    
    #
    # Odometer Slip
    #
    float32 odometer_slip_m
    
    #
    # Odometer Active
    # Documentation unclear, assuming 0 is inactive, and non-zero is active
    #
    uint8 odometer_active
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new KvhGeoFog3DOdometerState(null);
    if (msg.header !== undefined) {
      resolved.header = std_msgs.msg.Header.Resolve(msg.header)
    }
    else {
      resolved.header = new std_msgs.msg.Header()
    }

    if (msg.odometer_pulse_count !== undefined) {
      resolved.odometer_pulse_count = msg.odometer_pulse_count;
    }
    else {
      resolved.odometer_pulse_count = 0
    }

    if (msg.odometer_distance_m !== undefined) {
      resolved.odometer_distance_m = msg.odometer_distance_m;
    }
    else {
      resolved.odometer_distance_m = 0.0
    }

    if (msg.odometer_speed_mps !== undefined) {
      resolved.odometer_speed_mps = msg.odometer_speed_mps;
    }
    else {
      resolved.odometer_speed_mps = 0.0
    }

    if (msg.odometer_slip_m !== undefined) {
      resolved.odometer_slip_m = msg.odometer_slip_m;
    }
    else {
      resolved.odometer_slip_m = 0.0
    }

    if (msg.odometer_active !== undefined) {
      resolved.odometer_active = msg.odometer_active;
    }
    else {
      resolved.odometer_active = 0
    }

    return resolved;
    }
};

module.exports = KvhGeoFog3DOdometerState;
